<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="en">
<head>
<!-- Generated by javadoc (1.8.0_102) on Wed Jan 09 22:54:25 CET 2019 -->
<title>DijkstraAlgorithm</title>
<meta name="date" content="2019-01-09">
<link rel="stylesheet" type="text/css" href="../../../stylesheet.css" title="Style">
<script type="text/javascript" src="../../../script.js"></script>
</head>
<body>
<script type="text/javascript"><!--
    try {
        if (location.href.indexOf('is-external=true') == -1) {
            parent.document.title="DijkstraAlgorithm";
        }
    }
    catch(err) {
    }
//-->
var methods = {"i0":10,"i1":10,"i2":10,"i3":10,"i4":10,"i5":10};
var tabs = {65535:["t0","All Methods"],2:["t2","Instance Methods"],8:["t4","Concrete Methods"]};
var altColor = "altColor";
var rowColor = "rowColor";
var tableTab = "tableTab";
var activeTableTab = "activeTableTab";
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar.top">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.top.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../hr/fer/infmre/package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../index-files/index-1.html">Index</a></li>
<li><a href="../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li>Prev&nbsp;Class</li>
<li><a href="../../../hr/fer/infmre/Edge.html" title="class in hr.fer.infmre"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../index.html?hr/fer/infmre/DijkstraAlgorithm.html" target="_top">Frames</a></li>
<li><a href="DijkstraAlgorithm.html" target="_top">No&nbsp;Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li><a href="#field.summary">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li><a href="#field.detail">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a name="skip.navbar.top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
<div class="subTitle">hr.fer.infmre</div>
<h2 title="Class DijkstraAlgorithm" class="title">Class DijkstraAlgorithm</h2>
</div>
<div class="contentContainer">
<ul class="inheritance">
<li>java.lang.Object</li>
<li>
<ul class="inheritance">
<li>hr.fer.infmre.DijkstraAlgorithm</li>
</ul>
</li>
</ul>
<div class="description">
<ul class="blockList">
<li class="blockList">
<hr>
<br>
<pre>public class <span class="typeNameLabel">DijkstraAlgorithm</span>
extends java.lang.Object</pre>
<div class="block">Class representing the Dijkstra Algorithm.</div>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- =========== FIELD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="field.summary">
<!--   -->
</a>
<h3>Field Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Field Summary table, listing fields, and an explanation">
<caption><span>Fields</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Field and Description</th>
</tr>
<tr class="altColor">
<td class="colFirst"><code>private java.util.Set&lt;<a href="../../../hr/fer/infmre/Edge.html" title="class in hr.fer.infmre">Edge</a>&gt;</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../hr/fer/infmre/DijkstraAlgorithm.html#edges">edges</a></span></code>
<div class="block">All edges in the graph.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>private java.util.Set&lt;<a href="../../../hr/fer/infmre/Node.html" title="class in hr.fer.infmre">Node</a>&gt;</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../hr/fer/infmre/DijkstraAlgorithm.html#nodes">nodes</a></span></code>
<div class="block">All nodes in the graph.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>private java.util.Set&lt;<a href="../../../hr/fer/infmre/Node.html" title="class in hr.fer.infmre">Node</a>&gt;</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../hr/fer/infmre/DijkstraAlgorithm.html#settledNodes">settledNodes</a></span></code>
<div class="block">Collection of settled nodes.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>private java.util.Set&lt;<a href="../../../hr/fer/infmre/Node.html" title="class in hr.fer.infmre">Node</a>&gt;</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../hr/fer/infmre/DijkstraAlgorithm.html#unsettledNodes">unsettledNodes</a></span></code>
<div class="block">Collection of unsettled nodes.</div>
</td>
</tr>
</table>
</li>
</ul>
<!-- ======== CONSTRUCTOR SUMMARY ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor.summary">
<!--   -->
</a>
<h3>Constructor Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Constructor Summary table, listing constructors, and an explanation">
<caption><span>Constructors</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colOne" scope="col">Constructor and Description</th>
</tr>
<tr class="altColor">
<td class="colOne"><code><span class="memberNameLink"><a href="../../../hr/fer/infmre/DijkstraAlgorithm.html#DijkstraAlgorithm-hr.fer.infmre.Graph-">DijkstraAlgorithm</a></span>(<a href="../../../hr/fer/infmre/Graph.html" title="class in hr.fer.infmre">Graph</a>&nbsp;graph)</code>
<div class="block">Construcor for the Dijkstra Algorithm.</div>
</td>
</tr>
</table>
</li>
</ul>
<!-- ========== METHOD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="method.summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Method Summary table, listing methods, and an explanation">
<caption><span id="t0" class="activeTableTab"><span>All Methods</span><span class="tabEnd">&nbsp;</span></span><span id="t2" class="tableTab"><span><a href="javascript:show(2);">Instance Methods</a></span><span class="tabEnd">&nbsp;</span></span><span id="t4" class="tableTab"><span><a href="javascript:show(8);">Concrete Methods</a></span><span class="tabEnd">&nbsp;</span></span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Method and Description</th>
</tr>
<tr id="i0" class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../hr/fer/infmre/DijkstraAlgorithm.html#execute-hr.fer.infmre.Node-">execute</a></span>(<a href="../../../hr/fer/infmre/Node.html" title="class in hr.fer.infmre">Node</a>&nbsp;source)</code>
<div class="block">Executes algorithm for the given node as the source node.</div>
</td>
</tr>
<tr id="i1" class="rowColor">
<td class="colFirst"><code>private void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../hr/fer/infmre/DijkstraAlgorithm.html#findMinimalDistances-hr.fer.infmre.Node-">findMinimalDistances</a></span>(<a href="../../../hr/fer/infmre/Node.html" title="class in hr.fer.infmre">Node</a>&nbsp;node)</code>
<div class="block">Finds new minimal distances for all nodes that are neighbour to the given node.</div>
</td>
</tr>
<tr id="i2" class="altColor">
<td class="colFirst"><code>private int</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../hr/fer/infmre/DijkstraAlgorithm.html#getDistanceBetween-hr.fer.infmre.Node-hr.fer.infmre.Node-">getDistanceBetween</a></span>(<a href="../../../hr/fer/infmre/Node.html" title="class in hr.fer.infmre">Node</a>&nbsp;src,
                  <a href="../../../hr/fer/infmre/Node.html" title="class in hr.fer.infmre">Node</a>&nbsp;destination)</code>
<div class="block">Gets the distance between given source and destination nodes (edge weight between them).</div>
</td>
</tr>
<tr id="i3" class="rowColor">
<td class="colFirst"><code>private <a href="../../../hr/fer/infmre/Node.html" title="class in hr.fer.infmre">Node</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../hr/fer/infmre/DijkstraAlgorithm.html#getMinimum-java.util.Set-">getMinimum</a></span>(java.util.Set&lt;<a href="../../../hr/fer/infmre/Node.html" title="class in hr.fer.infmre">Node</a>&gt;&nbsp;nodes)</code>
<div class="block">Gets node with the minimum distance from the given set of nodes.</div>
</td>
</tr>
<tr id="i4" class="altColor">
<td class="colFirst"><code>private java.util.List&lt;<a href="../../../hr/fer/infmre/Node.html" title="class in hr.fer.infmre">Node</a>&gt;</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../hr/fer/infmre/DijkstraAlgorithm.html#getNeighbors-hr.fer.infmre.Node-">getNeighbors</a></span>(<a href="../../../hr/fer/infmre/Node.html" title="class in hr.fer.infmre">Node</a>&nbsp;node)</code>
<div class="block">Gets all neighbours of the given node.</div>
</td>
</tr>
<tr id="i5" class="rowColor">
<td class="colFirst"><code>private boolean</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../hr/fer/infmre/DijkstraAlgorithm.html#isSettled-hr.fer.infmre.Node-">isSettled</a></span>(<a href="../../../hr/fer/infmre/Node.html" title="class in hr.fer.infmre">Node</a>&nbsp;node)</code>
<div class="block">Checks if the given node is settled (settled - minimum distance and path are already calculated)</div>
</td>
</tr>
</table>
<ul class="blockList">
<li class="blockList"><a name="methods.inherited.from.class.java.lang.Object">
<!--   -->
</a>
<h3>Methods inherited from class&nbsp;java.lang.Object</h3>
<code>clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait</code></li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ============ FIELD DETAIL =========== -->
<ul class="blockList">
<li class="blockList"><a name="field.detail">
<!--   -->
</a>
<h3>Field Detail</h3>
<a name="nodes">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>nodes</h4>
<pre>private final&nbsp;java.util.Set&lt;<a href="../../../hr/fer/infmre/Node.html" title="class in hr.fer.infmre">Node</a>&gt; nodes</pre>
<div class="block">All nodes in the graph.</div>
</li>
</ul>
<a name="edges">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>edges</h4>
<pre>private final&nbsp;java.util.Set&lt;<a href="../../../hr/fer/infmre/Edge.html" title="class in hr.fer.infmre">Edge</a>&gt; edges</pre>
<div class="block">All edges in the graph.</div>
</li>
</ul>
<a name="settledNodes">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>settledNodes</h4>
<pre>private&nbsp;java.util.Set&lt;<a href="../../../hr/fer/infmre/Node.html" title="class in hr.fer.infmre">Node</a>&gt; settledNodes</pre>
<div class="block">Collection of settled nodes.</div>
</li>
</ul>
<a name="unsettledNodes">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>unsettledNodes</h4>
<pre>private&nbsp;java.util.Set&lt;<a href="../../../hr/fer/infmre/Node.html" title="class in hr.fer.infmre">Node</a>&gt; unsettledNodes</pre>
<div class="block">Collection of unsettled nodes.</div>
</li>
</ul>
</li>
</ul>
<!-- ========= CONSTRUCTOR DETAIL ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor.detail">
<!--   -->
</a>
<h3>Constructor Detail</h3>
<a name="DijkstraAlgorithm-hr.fer.infmre.Graph-">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>DijkstraAlgorithm</h4>
<pre>public&nbsp;DijkstraAlgorithm(<a href="../../../hr/fer/infmre/Graph.html" title="class in hr.fer.infmre">Graph</a>&nbsp;graph)</pre>
<div class="block">Construcor for the Dijkstra Algorithm.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>graph</code> - graph which algorithm will be used on</dd>
</dl>
</li>
</ul>
</li>
</ul>
<!-- ============ METHOD DETAIL ========== -->
<ul class="blockList">
<li class="blockList"><a name="method.detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a name="execute-hr.fer.infmre.Node-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>execute</h4>
<pre>public&nbsp;void&nbsp;execute(<a href="../../../hr/fer/infmre/Node.html" title="class in hr.fer.infmre">Node</a>&nbsp;source)</pre>
<div class="block">Executes algorithm for the given node as the source node.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>source</code> - node used as the source node in the algorithm</dd>
</dl>
</li>
</ul>
<a name="getMinimum-java.util.Set-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getMinimum</h4>
<pre>private&nbsp;<a href="../../../hr/fer/infmre/Node.html" title="class in hr.fer.infmre">Node</a>&nbsp;getMinimum(java.util.Set&lt;<a href="../../../hr/fer/infmre/Node.html" title="class in hr.fer.infmre">Node</a>&gt;&nbsp;nodes)</pre>
<div class="block">Gets node with the minimum distance from the given set of nodes.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>nodes</code> - set of nodes to be checked for the minimum distance node</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>minimum distance node</dd>
</dl>
</li>
</ul>
<a name="findMinimalDistances-hr.fer.infmre.Node-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>findMinimalDistances</h4>
<pre>private&nbsp;void&nbsp;findMinimalDistances(<a href="../../../hr/fer/infmre/Node.html" title="class in hr.fer.infmre">Node</a>&nbsp;node)</pre>
<div class="block">Finds new minimal distances for all nodes that are neighbour to the given node.
 If neighbour's current distance is bigger than new possible minimal distance then:
 Distance for neighbour node is calculated as:
 distance of the given node + the distance between the given node and the neighbour.
 Then the given node is added to the predecessors list of the neighbour node.

 If the distance of the given node is Integer.MAX_VALUE (which means it is unreachable),
 then minimal distances for its neighbours are not calculated (since it means they are not reachable as well).</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>node</code> - node whose neighbours' new minimal distances are calculated</dd>
</dl>
</li>
</ul>
<a name="getNeighbors-hr.fer.infmre.Node-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getNeighbors</h4>
<pre>private&nbsp;java.util.List&lt;<a href="../../../hr/fer/infmre/Node.html" title="class in hr.fer.infmre">Node</a>&gt;&nbsp;getNeighbors(<a href="../../../hr/fer/infmre/Node.html" title="class in hr.fer.infmre">Node</a>&nbsp;node)</pre>
<div class="block">Gets all neighbours of the given node.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>node</code> - node whose neighbours are searched</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>list of neighbour nodes</dd>
</dl>
</li>
</ul>
<a name="getDistanceBetween-hr.fer.infmre.Node-hr.fer.infmre.Node-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getDistanceBetween</h4>
<pre>private&nbsp;int&nbsp;getDistanceBetween(<a href="../../../hr/fer/infmre/Node.html" title="class in hr.fer.infmre">Node</a>&nbsp;src,
                               <a href="../../../hr/fer/infmre/Node.html" title="class in hr.fer.infmre">Node</a>&nbsp;destination)</pre>
<div class="block">Gets the distance between given source and destination nodes (edge weight between them).</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>src</code> - source node of the searched edge</dd>
<dd><code>destination</code> - destination node of the searched edge</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>distance (edge weight) between given nodes</dd>
</dl>
</li>
</ul>
<a name="isSettled-hr.fer.infmre.Node-">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>isSettled</h4>
<pre>private&nbsp;boolean&nbsp;isSettled(<a href="../../../hr/fer/infmre/Node.html" title="class in hr.fer.infmre">Node</a>&nbsp;node)</pre>
<div class="block">Checks if the given node is settled (settled - minimum distance and path are already calculated)</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>node</code> - checked node</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>true if given is settled, false otherwise</dd>
</dl>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar.bottom">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.bottom.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../hr/fer/infmre/package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../index-files/index-1.html">Index</a></li>
<li><a href="../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li>Prev&nbsp;Class</li>
<li><a href="../../../hr/fer/infmre/Edge.html" title="class in hr.fer.infmre"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../index.html?hr/fer/infmre/DijkstraAlgorithm.html" target="_top">Frames</a></li>
<li><a href="DijkstraAlgorithm.html" target="_top">No&nbsp;Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li><a href="#field.summary">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li><a href="#field.detail">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a name="skip.navbar.bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
</body>
</html>
